//<c>   Copyright 1991-2000 by Gerry J. Danen; all rights reserved.

//<t>   Get FILES= and BUFFERS= from CONFIG.SYS


#include"gd_tools.h"


#define TESTING


int FILES( void )                               // get FILES as set in CONFIG.SYS
{
    R_REGS ;
    S_SREGS ;
    UINT far    *ptr ;
    int         numfiles = 0 ;

    _AH = 0x52 ;
    INTDOSX(r,s);

    ptr = (UINT far *) MK_FP( _ES, _BX+0x04 );
    ptr = (UINT far *) MK_FP( ptr[1], ptr[0] );

    while ( FP_OFF( ptr ) != 0xFFFF )
    {
        numfiles += ptr[2];
        ptr = (unsigned int far *) MK_FP( ptr[1], ptr[0] );
    }

    return( numfiles );
}


int BUFFERS( void )                             // get BUFFERS as set in CONFIG.SYS
{
    R_REGS ;
    S_SREGS ;
    UCHAR far *ptr;
    int numbuffers = 0;

    _AX = 0x5200 ;

    INTDOSX(r,s);
    ptr = (UCHAR far *) MK_FP( _ES, _BX );

    numbuffers = *(ptr+0x3F);

    return( numbuffers );
}


#ifdef TESTING
void main( void )
{
    int ld = os_lastdrive();

    printf( "\nCONFIG.SYS:\n" );
    printf( "  FILES     = %d\n", FILES() );
    printf( "  BUFFERS   = %d\n", BUFFERS() );
    printf( "  LASTDRIVE = %d\n", '@'+ld );
}
#endif
